// Code generated by Stan version 2.9

#include <stan/model/model_header.hpp>

namespace mlogit2_model_namespace {

using std::istream;
using std::string;
using std::stringstream;
using std::vector;
using stan::io::dump;
using stan::math::lgamma;
using stan::model::prob_grad;
using namespace stan::math;

typedef Eigen::Matrix<double,Eigen::Dynamic,1> vector_d;
typedef Eigen::Matrix<double,1,Eigen::Dynamic> row_vector_d;
typedef Eigen::Matrix<double,Eigen::Dynamic,Eigen::Dynamic> matrix_d;

static int current_statement_begin__;
class mlogit2_model : public prob_grad {
private:
    int Nchoice;
    int Nvisit;
    int Nprov;
    int Nindiv;
    vector<int> visit;
    vector<int> prov;
    vector<int> indiv;
    vector_d price;
    int Nx;
    matrix_d x;
    vector<int> Nchoiceset;
    vector<int> y;
public:
    mlogit2_model(stan::io::var_context& context__,
        std::ostream* pstream__ = 0)
        : prob_grad(0) {
        current_statement_begin__ = -1;

        static const char* function__ = "mlogit2_model_namespace::mlogit2_model";
        (void) function__; // dummy call to supress warning
        size_t pos__;
        (void) pos__; // dummy call to supress warning
        std::vector<int> vals_i__;
        std::vector<double> vals_r__;
        context__.validate_dims("data initialization", "Nchoice", "int", context__.to_vec());
        Nchoice = int(0);
        vals_i__ = context__.vals_i("Nchoice");
        pos__ = 0;
        Nchoice = vals_i__[pos__++];
        context__.validate_dims("data initialization", "Nvisit", "int", context__.to_vec());
        Nvisit = int(0);
        vals_i__ = context__.vals_i("Nvisit");
        pos__ = 0;
        Nvisit = vals_i__[pos__++];
        context__.validate_dims("data initialization", "Nprov", "int", context__.to_vec());
        Nprov = int(0);
        vals_i__ = context__.vals_i("Nprov");
        pos__ = 0;
        Nprov = vals_i__[pos__++];
        context__.validate_dims("data initialization", "Nindiv", "int", context__.to_vec());
        Nindiv = int(0);
        vals_i__ = context__.vals_i("Nindiv");
        pos__ = 0;
        Nindiv = vals_i__[pos__++];
        context__.validate_dims("data initialization", "visit", "int", context__.to_vec(Nchoice));
        validate_non_negative_index("visit", "Nchoice", Nchoice);
        visit = std::vector<int>(Nchoice,int(0));
        vals_i__ = context__.vals_i("visit");
        pos__ = 0;
        size_t visit_limit_0__ = Nchoice;
        for (size_t i_0__ = 0; i_0__ < visit_limit_0__; ++i_0__) {
            visit[i_0__] = vals_i__[pos__++];
        }
        context__.validate_dims("data initialization", "prov", "int", context__.to_vec(Nchoice));
        validate_non_negative_index("prov", "Nchoice", Nchoice);
        prov = std::vector<int>(Nchoice,int(0));
        vals_i__ = context__.vals_i("prov");
        pos__ = 0;
        size_t prov_limit_0__ = Nchoice;
        for (size_t i_0__ = 0; i_0__ < prov_limit_0__; ++i_0__) {
            prov[i_0__] = vals_i__[pos__++];
        }
        context__.validate_dims("data initialization", "indiv", "int", context__.to_vec(Nvisit));
        validate_non_negative_index("indiv", "Nvisit", Nvisit);
        indiv = std::vector<int>(Nvisit,int(0));
        vals_i__ = context__.vals_i("indiv");
        pos__ = 0;
        size_t indiv_limit_0__ = Nvisit;
        for (size_t i_0__ = 0; i_0__ < indiv_limit_0__; ++i_0__) {
            indiv[i_0__] = vals_i__[pos__++];
        }
        validate_non_negative_index("price", "Nchoice", Nchoice);
        price = vector_d(Nchoice);
        context__.validate_dims("data initialization", "price", "vector_d", context__.to_vec(Nchoice));
        vals_r__ = context__.vals_r("price");
        pos__ = 0;
        size_t price_i_vec_lim__ = Nchoice;
        for (size_t i_vec__ = 0; i_vec__ < price_i_vec_lim__; ++i_vec__) {
            price[i_vec__] = vals_r__[pos__++];
        }
        context__.validate_dims("data initialization", "Nx", "int", context__.to_vec());
        Nx = int(0);
        vals_i__ = context__.vals_i("Nx");
        pos__ = 0;
        Nx = vals_i__[pos__++];
        context__.validate_dims("data initialization", "x", "matrix_d", context__.to_vec(Nchoice,Nx));
        validate_non_negative_index("x", "Nchoice", Nchoice);
        validate_non_negative_index("x", "Nx", Nx);
        x = matrix_d(Nchoice,Nx);
        vals_r__ = context__.vals_r("x");
        pos__ = 0;
        size_t x_m_mat_lim__ = Nchoice;
        size_t x_n_mat_lim__ = Nx;
        for (size_t n_mat__ = 0; n_mat__ < x_n_mat_lim__; ++n_mat__) {
            for (size_t m_mat__ = 0; m_mat__ < x_m_mat_lim__; ++m_mat__) {
                x(m_mat__,n_mat__) = vals_r__[pos__++];
            }
        }
        context__.validate_dims("data initialization", "Nchoiceset", "int", context__.to_vec(Nvisit));
        validate_non_negative_index("Nchoiceset", "Nvisit", Nvisit);
        Nchoiceset = std::vector<int>(Nvisit,int(0));
        vals_i__ = context__.vals_i("Nchoiceset");
        pos__ = 0;
        size_t Nchoiceset_limit_0__ = Nvisit;
        for (size_t i_0__ = 0; i_0__ < Nchoiceset_limit_0__; ++i_0__) {
            Nchoiceset[i_0__] = vals_i__[pos__++];
        }
        context__.validate_dims("data initialization", "y", "int", context__.to_vec(Nvisit));
        validate_non_negative_index("y", "Nvisit", Nvisit);
        y = std::vector<int>(Nvisit,int(0));
        vals_i__ = context__.vals_i("y");
        pos__ = 0;
        size_t y_limit_0__ = Nvisit;
        for (size_t i_0__ = 0; i_0__ < y_limit_0__; ++i_0__) {
            y[i_0__] = vals_i__[pos__++];
        }

        // validate data
        check_greater_or_equal(function__,"Nchoice",Nchoice,1);
        check_greater_or_equal(function__,"Nvisit",Nvisit,1);
        check_greater_or_equal(function__,"Nprov",Nprov,1);
        check_greater_or_equal(function__,"Nindiv",Nindiv,1);
        for (int k0__ = 0; k0__ < Nchoice; ++k0__) {
            check_greater_or_equal(function__,"visit[k0__]",visit[k0__],1);
            check_less_or_equal(function__,"visit[k0__]",visit[k0__],Nvisit);
        }
        for (int k0__ = 0; k0__ < Nchoice; ++k0__) {
            check_greater_or_equal(function__,"prov[k0__]",prov[k0__],1);
            check_less_or_equal(function__,"prov[k0__]",prov[k0__],Nprov);
        }
        for (int k0__ = 0; k0__ < Nvisit; ++k0__) {
            check_greater_or_equal(function__,"indiv[k0__]",indiv[k0__],1);
            check_less_or_equal(function__,"indiv[k0__]",indiv[k0__],Nindiv);
        }
        check_greater_or_equal(function__,"Nx",Nx,1);
        for (int k0__ = 0; k0__ < Nvisit; ++k0__) {
            check_greater_or_equal(function__,"Nchoiceset[k0__]",Nchoiceset[k0__],1);
            check_less_or_equal(function__,"Nchoiceset[k0__]",Nchoiceset[k0__],Nprov);
        }
        for (int k0__ = 0; k0__ < Nvisit; ++k0__) {
            check_greater_or_equal(function__,"y[k0__]",y[k0__],1);
            check_less_or_equal(function__,"y[k0__]",y[k0__],Nprov);
        }

        double DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning


        // initialize transformed variables to avoid seg fault on val access

        try {
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e,current_statement_begin__);
            // Next line prevents compiler griping about no return
throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }

        // validate transformed data

        // set parameter ranges
        num_params_r__ = 0U;
        param_ranges_i__.clear();
        num_params_r__ += (Nprov - 1);
        ++num_params_r__;
        ++num_params_r__;
        num_params_r__ += Nx;
    }

    ~mlogit2_model() { }


    void transform_inits(const stan::io::var_context& context__,
                         std::vector<int>& params_i__,
                         std::vector<double>& params_r__,
                         std::ostream* pstream__) const {
        stan::io::writer<double> writer__(params_r__,params_i__);
        size_t pos__;
        (void) pos__; // dummy call to supress warning
        std::vector<double> vals_r__;
        std::vector<int> vals_i__;

        if (!(context__.contains_r("xi_free")))
            throw std::runtime_error("variable xi_free missing");
        vals_r__ = context__.vals_r("xi_free");
        pos__ = 0U;
        context__.validate_dims("initialization", "xi_free", "vector_d", context__.to_vec((Nprov - 1)));
        vector_d xi_free((Nprov - 1));
        for (int j1__ = 0U; j1__ < (Nprov - 1); ++j1__)
            xi_free(j1__) = vals_r__[pos__++];
        try {
            writer__.vector_unconstrain(xi_free);
        } catch (const std::exception& e) { 
            throw std::runtime_error(std::string("Error transforming variable xi_free: ") + e.what());
        }

        if (!(context__.contains_r("alpha_mu")))
            throw std::runtime_error("variable alpha_mu missing");
        vals_r__ = context__.vals_r("alpha_mu");
        pos__ = 0U;
        context__.validate_dims("initialization", "alpha_mu", "double", context__.to_vec());
        double alpha_mu(0);
        alpha_mu = vals_r__[pos__++];
        try {
            writer__.scalar_lub_unconstrain(-(5),5,alpha_mu);
        } catch (const std::exception& e) { 
            throw std::runtime_error(std::string("Error transforming variable alpha_mu: ") + e.what());
        }

        if (!(context__.contains_r("alpha_s")))
            throw std::runtime_error("variable alpha_s missing");
        vals_r__ = context__.vals_r("alpha_s");
        pos__ = 0U;
        context__.validate_dims("initialization", "alpha_s", "double", context__.to_vec());
        double alpha_s(0);
        alpha_s = vals_r__[pos__++];
        try {
            writer__.scalar_lb_unconstrain(9.9999999999999995e-07,alpha_s);
        } catch (const std::exception& e) { 
            throw std::runtime_error(std::string("Error transforming variable alpha_s: ") + e.what());
        }

        if (!(context__.contains_r("beta")))
            throw std::runtime_error("variable beta missing");
        vals_r__ = context__.vals_r("beta");
        pos__ = 0U;
        context__.validate_dims("initialization", "beta", "vector_d", context__.to_vec(Nx));
        vector_d beta(Nx);
        for (int j1__ = 0U; j1__ < Nx; ++j1__)
            beta(j1__) = vals_r__[pos__++];
        try {
            writer__.vector_lub_unconstrain(-(5),5,beta);
        } catch (const std::exception& e) { 
            throw std::runtime_error(std::string("Error transforming variable beta: ") + e.what());
        }

        params_r__ = writer__.data_r();
        params_i__ = writer__.data_i();
    }

    void transform_inits(const stan::io::var_context& context,
                         Eigen::Matrix<double,Eigen::Dynamic,1>& params_r,
                         std::ostream* pstream__) const {
      std::vector<double> params_r_vec;
      std::vector<int> params_i_vec;
      transform_inits(context, params_i_vec, params_r_vec, pstream__);
      params_r.resize(params_r_vec.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r(i) = params_r_vec[i];
    }


    template <bool propto__, bool jacobian__, typename T__>
    T__ log_prob(vector<T__>& params_r__,
                 vector<int>& params_i__,
                 std::ostream* pstream__ = 0) const {

        T__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning

        T__ lp__(0.0);
        stan::math::accumulator<T__> lp_accum__;

        // model parameters
        stan::io::reader<T__> in__(params_r__,params_i__);

        Eigen::Matrix<T__,Eigen::Dynamic,1>  xi_free;
        (void) xi_free;   // dummy to suppress unused var warning
        if (jacobian__)
            xi_free = in__.vector_constrain((Nprov - 1),lp__);
        else
            xi_free = in__.vector_constrain((Nprov - 1));

        T__ alpha_mu;
        (void) alpha_mu;   // dummy to suppress unused var warning
        if (jacobian__)
            alpha_mu = in__.scalar_lub_constrain(-(5),5,lp__);
        else
            alpha_mu = in__.scalar_lub_constrain(-(5),5);

        T__ alpha_s;
        (void) alpha_s;   // dummy to suppress unused var warning
        if (jacobian__)
            alpha_s = in__.scalar_lb_constrain(9.9999999999999995e-07,lp__);
        else
            alpha_s = in__.scalar_lb_constrain(9.9999999999999995e-07);

        Eigen::Matrix<T__,Eigen::Dynamic,1>  beta;
        (void) beta;   // dummy to suppress unused var warning
        if (jacobian__)
            beta = in__.vector_lub_constrain(-(5),5,Nx,lp__);
        else
            beta = in__.vector_lub_constrain(-(5),5,Nx);


        // transformed parameters
        Eigen::Matrix<T__,Eigen::Dynamic,1>  alpha(Nindiv);
        (void) alpha;  // dummy to suppress unused var warning
        stan::math::fill(alpha,DUMMY_VAR__);
        Eigen::Matrix<T__,Eigen::Dynamic,1>  xi(Nprov);
        (void) xi;  // dummy to suppress unused var warning
        stan::math::fill(xi,DUMMY_VAR__);

        // initialize transformed variables to avoid seg fault on val access
        stan::math::fill(alpha,DUMMY_VAR__);
        stan::math::fill(xi,DUMMY_VAR__);

        try {
            current_statement_begin__ = 32;
            stan::math::assign(get_base1_lhs(xi,1,"xi",1), 0);
            current_statement_begin__ = 33;
            for (int i = 2; i <= Nprov; ++i) {
                current_statement_begin__ = 34;
                stan::math::assign(get_base1_lhs(xi,i,"xi",1), get_base1(xi_free,(i - 1),"xi_free",1));
            }
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e,current_statement_begin__);
            // Next line prevents compiler griping about no return
throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }

        // validate transformed parameters
        for (int i0__ = 0; i0__ < Nindiv; ++i0__) {
            if (stan::math::is_uninitialized(alpha(i0__))) {
                std::stringstream msg__;
                msg__ << "Undefined transformed parameter: alpha" << '[' << i0__ << ']';
                throw std::runtime_error(msg__.str());
            }
        }
        for (int i0__ = 0; i0__ < Nprov; ++i0__) {
            if (stan::math::is_uninitialized(xi(i0__))) {
                std::stringstream msg__;
                msg__ << "Undefined transformed parameter: xi" << '[' << i0__ << ']';
                throw std::runtime_error(msg__.str());
            }
        }

        const char* function__ = "validate transformed params";
        (void) function__; // dummy to suppress unused var warning

        // model body
        try {
            {
                int pos(0);
                (void) pos;  // dummy to suppress unused var warning
                current_statement_begin__ = 39;
                stan::math::assign(pos, 1);
                current_statement_begin__ = 42;
                lp_accum__.add(normal_log<propto__>(alpha, alpha_mu, alpha_s));
                current_statement_begin__ = 47;
                for (int n = 1; n <= Nvisit; ++n) {
                    current_statement_begin__ = 48;
                    lp_accum__.add(categorical_logit_log<propto__>(get_base1(y,n,"y",1), add(add(stan::model::rvalue(xi, stan::model::cons_list(stan::model::index_multi(segment(prov,pos,get_base1(Nchoiceset,n,"Nchoiceset",1))), stan::model::nil_index_list()), "xi"),multiply(segment(price,pos,get_base1(Nchoiceset,n,"Nchoiceset",1)),get_base1(alpha,get_base1(indiv,n,"indiv",1),"alpha",1))),multiply(block(x,pos,1,get_base1(Nchoiceset,n,"Nchoiceset",1),Nx),beta))));
                    current_statement_begin__ = 52;
                    stan::math::assign(pos, (pos + get_base1(Nchoiceset,n,"Nchoiceset",1)));
                }
            }
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e,current_statement_begin__);
            // Next line prevents compiler griping about no return
throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }

        lp_accum__.add(lp__);
        return lp_accum__.sum();

    } // log_prob()

    template <bool propto, bool jacobian, typename T_>
    T_ log_prob(Eigen::Matrix<T_,Eigen::Dynamic,1>& params_r,
               std::ostream* pstream = 0) const {
      std::vector<T_> vec_params_r;
      vec_params_r.reserve(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        vec_params_r.push_back(params_r(i));
      std::vector<int> vec_params_i;
      return log_prob<propto,jacobian,T_>(vec_params_r, vec_params_i, pstream);
    }


    void get_param_names(std::vector<std::string>& names__) const {
        names__.resize(0);
        names__.push_back("xi_free");
        names__.push_back("alpha_mu");
        names__.push_back("alpha_s");
        names__.push_back("beta");
        names__.push_back("alpha");
        names__.push_back("xi");
    }


    void get_dims(std::vector<std::vector<size_t> >& dimss__) const {
        dimss__.resize(0);
        std::vector<size_t> dims__;
        dims__.resize(0);
        dims__.push_back((Nprov - 1));
        dimss__.push_back(dims__);
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(Nx);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(Nindiv);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(Nprov);
        dimss__.push_back(dims__);
    }

    template <typename RNG>
    void write_array(RNG& base_rng__,
                     std::vector<double>& params_r__,
                     std::vector<int>& params_i__,
                     std::vector<double>& vars__,
                     bool include_tparams__ = true,
                     bool include_gqs__ = true,
                     std::ostream* pstream__ = 0) const {
        vars__.resize(0);
        stan::io::reader<double> in__(params_r__,params_i__);
        static const char* function__ = "mlogit2_model_namespace::write_array";
        (void) function__; // dummy call to supress warning
        // read-transform, write parameters
        vector_d xi_free = in__.vector_constrain((Nprov - 1));
        double alpha_mu = in__.scalar_lub_constrain(-(5),5);
        double alpha_s = in__.scalar_lb_constrain(9.9999999999999995e-07);
        vector_d beta = in__.vector_lub_constrain(-(5),5,Nx);
        for (int k_0__ = 0; k_0__ < (Nprov - 1); ++k_0__) {
            vars__.push_back(xi_free[k_0__]);
        }
        vars__.push_back(alpha_mu);
        vars__.push_back(alpha_s);
        for (int k_0__ = 0; k_0__ < Nx; ++k_0__) {
            vars__.push_back(beta[k_0__]);
        }

        if (!include_tparams__) return;
        // declare and define transformed parameters
        double lp__ = 0.0;
        (void) lp__; // dummy call to supress warning
        stan::math::accumulator<double> lp_accum__;

        vector_d alpha(Nindiv);
        (void) alpha;  // dummy to suppress unused var warning
        vector_d xi(Nprov);
        (void) xi;  // dummy to suppress unused var warning

        try {
            current_statement_begin__ = 32;
            stan::math::assign(get_base1_lhs(xi,1,"xi",1), 0);
            current_statement_begin__ = 33;
            for (int i = 2; i <= Nprov; ++i) {
                current_statement_begin__ = 34;
                stan::math::assign(get_base1_lhs(xi,i,"xi",1), get_base1(xi_free,(i - 1),"xi_free",1));
            }
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e,current_statement_begin__);
            // Next line prevents compiler griping about no return
throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }

        // validate transformed parameters

        // write transformed parameters
        for (int k_0__ = 0; k_0__ < Nindiv; ++k_0__) {
            vars__.push_back(alpha[k_0__]);
        }
        for (int k_0__ = 0; k_0__ < Nprov; ++k_0__) {
            vars__.push_back(xi[k_0__]);
        }

        if (!include_gqs__) return;
        // declare and define generated quantities

        double DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning


        // initialize transformed variables to avoid seg fault on val access

        try {
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e,current_statement_begin__);
            // Next line prevents compiler griping about no return
throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }

        // validate generated quantities

        // write generated quantities
    }

    template <typename RNG>
    void write_array(RNG& base_rng,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& params_r,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& vars,
                     bool include_tparams = true,
                     bool include_gqs = true,
                     std::ostream* pstream = 0) const {
      std::vector<double> params_r_vec(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r_vec[i] = params_r(i);
      std::vector<double> vars_vec;
      std::vector<int> params_i_vec;
      write_array(base_rng,params_r_vec,params_i_vec,vars_vec,include_tparams,include_gqs,pstream);
      vars.resize(vars_vec.size());
      for (int i = 0; i < vars.size(); ++i)
        vars(i) = vars_vec[i];
    }

    static std::string model_name() {
        return "mlogit2_model";
    }


    void constrained_param_names(std::vector<std::string>& param_names__,
                                 bool include_tparams__ = true,
                                 bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        for (int k_0__ = 1; k_0__ <= (Nprov - 1); ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "xi_free" << '.' << k_0__;
            param_names__.push_back(param_name_stream__.str());
        }
        param_name_stream__.str(std::string());
        param_name_stream__ << "alpha_mu";
        param_names__.push_back(param_name_stream__.str());
        param_name_stream__.str(std::string());
        param_name_stream__ << "alpha_s";
        param_names__.push_back(param_name_stream__.str());
        for (int k_0__ = 1; k_0__ <= Nx; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "beta" << '.' << k_0__;
            param_names__.push_back(param_name_stream__.str());
        }

        if (!include_gqs__ && !include_tparams__) return;
        for (int k_0__ = 1; k_0__ <= Nindiv; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "alpha" << '.' << k_0__;
            param_names__.push_back(param_name_stream__.str());
        }
        for (int k_0__ = 1; k_0__ <= Nprov; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "xi" << '.' << k_0__;
            param_names__.push_back(param_name_stream__.str());
        }

        if (!include_gqs__) return;
    }


    void unconstrained_param_names(std::vector<std::string>& param_names__,
                                   bool include_tparams__ = true,
                                   bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        for (int k_0__ = 1; k_0__ <= (Nprov - 1); ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "xi_free" << '.' << k_0__;
            param_names__.push_back(param_name_stream__.str());
        }
        param_name_stream__.str(std::string());
        param_name_stream__ << "alpha_mu";
        param_names__.push_back(param_name_stream__.str());
        param_name_stream__.str(std::string());
        param_name_stream__ << "alpha_s";
        param_names__.push_back(param_name_stream__.str());
        for (int k_0__ = 1; k_0__ <= Nx; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "beta" << '.' << k_0__;
            param_names__.push_back(param_name_stream__.str());
        }

        if (!include_gqs__ && !include_tparams__) return;
        for (int k_0__ = 1; k_0__ <= Nindiv; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "alpha" << '.' << k_0__;
            param_names__.push_back(param_name_stream__.str());
        }
        for (int k_0__ = 1; k_0__ <= Nprov; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "xi" << '.' << k_0__;
            param_names__.push_back(param_name_stream__.str());
        }

        if (!include_gqs__) return;
    }

}; // model

} // namespace

typedef mlogit2_model_namespace::mlogit2_model stan_model;

